# TODO:
# - debuginfo package wrt module debug stuff
# - configurable microcode location (see Debian)

%{!?kernel: %{expand: %%define kernel %(uname -r)}}
%define ksrc %{_usrsrc}/kernels/%{kernel}-%{_target_cpu}

Name:           em8300
Version:        0.15.0
Release:        0.%{mysig}
Summary:        DXR3/Hollywood Plus MPEG decoder card support tools

Group:          System Environment/Libraries
License:        GPL
URL:            http://dxr3.sourceforge.net/
Source0:        http://download.sourceforge.net/dxr3/%{name}-%{version}.tar.gz
Source1:        %{name}-README-console.perms
Source2:        %{name}-README-modprobe.conf
Patch0:         %{name}-adv7170-wss.patch
Patch1:         %{name}-2612pre.patch
Patch2:         %{name}-udev.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{!?_without_userland:1}
BuildRequires:  gtk+-devel
BuildRequires:  desktop-file-utils
%endif
Requires:       kernel-module-%{name} = %{version}
Obsoletes:      libdxr3 < 0.15.0-0.lvn.5

%description
%{summary}.

%package        devel
Summary:        Development files for DXR3/Hollywood Plus MPEG decoder cards
Group:          Development/Libraries
# Does not require main package on purpose!
Requires:       %{_includedir}/linux
Obsoletes:      libdxr3-devel < 0.15.0-0.lvn.5

%description    devel
%{summary}.

%package     -n kernel-module-%{name}-%{kernel}
Summary:        Kernel modules for DXR3/Hollywood Plus MPEG decoder cards
Group:          System Environment/Kernel
Provides:       kernel-module-%{name} = %{version}
%if 0%{!?_without_modules:1}
BuildRequires:  kernel-devel = %{kernel}
%endif
Requires:       udev
Requires:       %{name} = %{version}
Requires:       /boot/vmlinuz-%{kernel}
Requires(pre):  %{_sbindir}/groupadd
Requires(post): modutils
Requires(postun): modutils

%description -n kernel-module-%{name}-%{kernel}
DXR3/Hollywood Plus MPEG decoder card kernel modules built for kernel
%{kernel} (%{_target_cpu}).


%prep
%setup -q
%patch0
%patch1
%patch2
install -pm 644 %{SOURCE1} README-console.perms
install -pm 644 %{SOURCE2} README-modprobe.conf


%build

%if 0%{!?_without_userland:1}
%ifarch x86_64
export CFLAGS="-fPIC $RPM_OPT_FLAGS"
%endif
%configure --disable-dependency-tracking
make %{?_smp_mflags}
unset CFLAGS
%endif

%if 0%{!?_without_modules:1}
%{?_with_2612:export EM8300_I2C_FORCE_API=2612}
cd modules && make %{?_smp_mflags} KERNEL_LOCATION=%{ksrc} V=1 && cd ..
%endif


%install
rm -rf $RPM_BUILD_ROOT

%if 0%{!?_without_userland:1}
make install DESTDIR=$RPM_BUILD_ROOT
for f in */*.desktop ; do
  desktop-file-install \
    --vendor livna \
    --mode 644 \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications \
    --add-category X-Livna \
    $f
done
install -Dpm 644 modules/em8300.uc $RPM_BUILD_ROOT%{_datadir}/misc/em8300.uc
install -Dpm 644 em8300setup/em8300setup.1 \
  $RPM_BUILD_ROOT%{_mandir}/man1/em8300setup.1
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/{em8300.sysv,modules.tar.gz}
rm -r $RPM_BUILD_ROOT%{_libdir} $RPM_BUILD_ROOT%{_includedir}/libdxr3
%endif

%if 0%{!?_without_modules:1}
cd modules
make install \
  DESTDIR=$RPM_BUILD_ROOT KERNEL_LOCATION=%{ksrc} MODINST=extra/em8300
cd ..
install -Dpm 644 modules/em8300-udev.rules \
  $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/49-%{name}.rules
%endif


%clean
rm -rf $RPM_BUILD_ROOT


%pre -n kernel-module-%{name}-%{kernel}
%{_sbindir}/groupadd -r video 2>/dev/null || :

%post -n kernel-module-%{name}-%{kernel}
depmod -ae -F /boot/System.map-%{kernel} %{kernel} >/dev/null || :

%postun -n kernel-module-%{name}-%{kernel}
depmod -ae -F /boot/System.map-%{kernel} %{kernel} >/dev/null || :


%if 0%{!?_without_userland:1}
%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING README README-console.perms overlay/configs/
%{_bindir}/autocal
%{_bindir}/dhc
%{_bindir}/dxr3view
%{_bindir}/em8300setup
%{_datadir}/applications/*.desktop
%{_datadir}/misc/em8300.uc
%{_mandir}/man1/em8300setup.1*

%files devel
%defattr(-,root,root,-)
%{_includedir}/linux/em8300.h
%{_datadir}/%{name}/
%endif

%if 0%{!?_without_modules:1}
%files -n kernel-module-%{name}-%{kernel}
%defattr(644,root,root,755)
%doc modules/README-modoptions README-modprobe.conf
%config %{_sysconfdir}/udev/rules.d/*-%{name}.rules
/lib/modules/%{kernel}/extra/
%endif


%changelog
* Wed Sep 21 2005 Milan Kerslager <kerslage@linux.cz> 0.15.0-0.ker.rhel4
- rebuild for RHEL4 (package from http://rpm.livna.org/fedora/4/i386/SRPMS.lvn)

* Mon Jul 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.5
- Drop libdxr3, nothing uses it and it'll be removed in next upstream release.

* Fri Jul  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.4
- Install modules into extra/em8300.

* Sat Jun 18 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.3
- Use udev rules.d snippet for device permissions.

* Sun Jun 12 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.2
- Add "--with 2612" rpmbuild option to enable building with 2.6.12-pre
  kernels that report themselves as 2.6.11, such as early FC4 ones.

* Wed Jun  1 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.1
- 0.15.0.

* Sun May 29 2005 Thorsten Leemhuis <fedora at leemhuis.info> - 0.15.0-0.lvn.0.15.rc4
- Build userspace with -fPIC on x86_64 to fix build error

* Tue May 24 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.14.rc4
- 0.15.0rc4, memset patch applied upstream.

* Fri May 13 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.13.rc3
- Improve optional rpmbuild options:
  --without modules: do not build the kernel modules
  --without userland: do not build the userland stuff

* Fri Apr 29 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.rc3
- 0.15.0.rc3.

* Sun Apr 10 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.rc2
- 0.15.0.rc2.
- Drop unused Provides: kernel-module.
- Move video group creation from main to kernel module package(s).

* Sat Apr  2 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.cvs20050331
- Add FC4 kernel-devel and new kernel-module-devel compatibility.

* Thu Mar 31 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050331
- Update to upstream CVS HEAD as of now, many patches applied upstream.

* Sat Mar 26 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050326
- Update to upstream CVS HEAD as of now.
- Revert microcode location to upstream default (/usr/share/misc/em8300.uc).

* Tue Mar  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050308
- Update to upstream CVS HEAD as of now.

* Sun Feb 27 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.10.cvs20050227
- Update tarball naming and modprobe.conf README, no upstream changes.

* Mon Feb  7 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.10.cvs20041117
- Use my pre-rolled/patched tarball.
- Remove unnecessary Epochs.

* Tue Jan 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.9.cvs20041117
- URLize patches and extra sources.

* Fri Jan  7 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.8.cvs20041117
- Remove "manual" device node creation, let udev handle all of it.
- Add console.perms README.

* Mon Dec  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.7.cvs20041117
- Apply ADV7170 WSS patch from Seppo Ingalsuo.
- Include upstream ALSA patch, but don't apply it just yet.
- Fix em8300setup usage message.
- Get rid of acconfig.h to appease newer autotools.
- Make "--with(out) kmod" conditional sections smaller in the specfile.

* Sun Dec  5 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.6.cvs20041117
- Create the video group in the correct place.

* Sun Nov 28 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.5.cvs20041117
- Adjust setup for udev.
- Create/use the video group.
- Avoid creating /usr/include/linux twice during build.

* Wed Nov 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20041117
- Update to 20041117, most patches applied upstream.

* Wed Nov  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20041101
- Update to 20041101 + upstream patches.

* Sat Oct  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20040907
- Fix module directory permissions.

* Mon Sep 13 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.3.cvs20040907
- Install modules into /lib/modules/$uname/updates/em8300.
- Add URL to tarball.

* Sat Sep 11 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.2.cvs20040907
- Reset mode of installed modules to 644.

* Tue Sep  7 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040907
- Update to 0.15.0.cvs20040907.
- Disable dependency tracking to speed up the build.

* Sun Aug 29 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040827
- Update to 0.15.0.cvs20040827.

* Fri Jul 30 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040730
- Reorganize packaging, introduce libdxr3* as real subpackages.
- Add "--without kmod" rpmbuild option for skipping the kernel module build
  and "--with kmod" for building only the kernel modules.
- s/fdr/lvn/ due to non open source microcode.

* Sat Jul  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.fdr.0.1.cvs20040702
- Update to 0.15.0.cvs20040702.

* Wed Mar 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.14.0-0.fdr.1
- Update to 0.14.0.

* Fri Feb 20 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.3.cvs20040220
- Update to CVS 20040220.

* Mon Feb  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.3.cvs20040107
- Update to kmodhelper 0.9.8.

* Sat Jan 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.2.cvs20040107
- Drop release from the dependency between the kernel module and main package.
- Update kmodhelper to 0.9.7.
- Use MAKEDEV for creating the device nodes.
- Spec file cleanups.

* Tue Jan  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.1.cvs20040107
- First build.
